/**
 * Vue Currency Input 1.7.1
 * (c) 2019 Matthias Stiller
 * @license MIT
 */
(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(require('vue')) :
  typeof define === 'function' && define.amd ? define(['vue'], factory) :
  (global = global || self, factory(global.Vue));
}(this, function (Vue) { 'use strict';

  Vue = Vue && Vue.hasOwnProperty('default') ? Vue['default'] : Vue;

  var defaultOptions = {
    locale: undefined,
    currency: 'EUR',
    distractionFree: true,
    min: null,
    max: null,
    validateOnInput: false
  };

  var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

  function unwrapExports (x) {
  	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
  }

  function createCommonjsModule(fn, module) {
  	return module = { exports: {} }, fn(module, module.exports), module.exports;
  }

  var textMaskCore = createCommonjsModule(function (module, exports) {
  !function(e,r){module.exports=r();}(commonjsGlobal,function(){return function(e){function r(n){if(t[n]){ return t[n].exports; }var o=t[n]={exports:{},id:n,loaded:!1};return e[n].call(o.exports,o,o.exports,r),o.loaded=!0,o.exports}var t={};return r.m=e,r.c=t,r.p="",r(0)}([function(e,r,t){function n(e){return e&&e.__esModule?e:{default:e}}Object.defineProperty(r,"__esModule",{value:!0});var o=t(3);Object.defineProperty(r,"conformToMask",{enumerable:!0,get:function(){return n(o).default}});var i=t(2);Object.defineProperty(r,"adjustCaretPosition",{enumerable:!0,get:function(){return n(i).default}});var a=t(5);Object.defineProperty(r,"createTextMaskInputElement",{enumerable:!0,get:function(){return n(a).default}});},function(e,r){Object.defineProperty(r,"__esModule",{value:!0}),r.placeholderChar="_",r.strFunction="function";},function(e,r){function t(e){var r=e.previousConformedValue,t=void 0===r?o:r,i=e.previousPlaceholder,a=void 0===i?o:i,u=e.currentCaretPosition,l=void 0===u?0:u,s=e.conformedValue,f=e.rawValue,d=e.placeholderChar,c=e.placeholder,p=e.indexesOfPipedChars,v=void 0===p?n:p,h=e.caretTrapIndexes,m=void 0===h?n:h;if(0===l||!f.length){ return 0; }var y=f.length,g=t.length,b=c.length,C=s.length,P=y-g,k=P>0,x=0===g,O=P>1&&!k&&!x;if(O){ return l; }var T=k&&(t===s||s===c),w=0,M=void 0,S=void 0;if(T){ w=l-P; }else{var j=s.toLowerCase(),_=f.toLowerCase(),V=_.substr(0,l).split(o),A=V.filter(function(e){return j.indexOf(e)!==-1});S=A[A.length-1];var N=a.substr(0,A.length).split(o).filter(function(e){return e!==d}).length,E=c.substr(0,A.length).split(o).filter(function(e){return e!==d}).length,F=E!==N,R=void 0!==a[A.length-1]&&void 0!==c[A.length-2]&&a[A.length-1]!==d&&a[A.length-1]!==c[A.length-1]&&a[A.length-1]===c[A.length-2];!k&&(F||R)&&N>0&&c.indexOf(S)>-1&&void 0!==f[l]&&(M=!0,S=f[l]);for(var I=v.map(function(e){return j[e]}),J=I.filter(function(e){return e===S}).length,W=A.filter(function(e){return e===S}).length,q=c.substr(0,c.indexOf(d)).split(o).filter(function(e,r){return e===S&&f[r]!==e}).length,L=q+W+J+(M?1:0),z=0,B=0;B<C;B++){var D=j[B];if(w=B+1,D===S&&z++,z>=L){ break }}}if(k){for(var G=w,H=w;H<=b;H++){ if(c[H]===d&&(G=H),c[H]===d||m.indexOf(H)!==-1||H===b){ return G } }}else if(M){for(var K=w-1;K>=0;K--){ if(s[K]===S||m.indexOf(K)!==-1||0===K){ return K } }}else { for(var Q=w;Q>=0;Q--){ if(c[Q-1]===d||m.indexOf(Q)!==-1||0===Q){ return Q } } }}Object.defineProperty(r,"__esModule",{value:!0}),r.default=t;var n=[],o="";},function(e,r,t){function n(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:l,r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:u,t=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};if(!(0, i.isArray)(r)){if(("undefined"==typeof r?"undefined":o(r))!==a.strFunction){ throw new Error("Text-mask:conformToMask; The mask property must be an array."); }r=r(e,t),r=(0, i.processCaretTraps)(r).maskWithoutCaretTraps;}var n=t.guide,s=void 0===n||n,f=t.previousConformedValue,d=void 0===f?l:f,c=t.placeholderChar,p=void 0===c?a.placeholderChar:c,v=t.placeholder,h=void 0===v?(0, i.convertMaskToPlaceholder)(r,p):v,m=t.currentCaretPosition,y=t.keepCharPositions,g=s===!1&&void 0!==d,b=e.length,C=d.length,P=h.length,k=r.length,x=b-C,O=x>0,T=m+(O?-x:0),w=T+Math.abs(x);if(y===!0&&!O){for(var M=l,S=T;S<w;S++){ h[S]===p&&(M+=p); }e=e.slice(0,T)+M+e.slice(T,b);}for(var j=e.split(l).map(function(e,r){return {char:e,isNew:r>=T&&r<w}}),_=b-1;_>=0;_--){var V=j[_].char;if(V!==p){var A=_>=T&&C===k;V===h[A?_-x:_]&&j.splice(_,1);}}var N=l,E=!1;e:for(var F=0;F<P;F++){var R=h[F];if(R===p){if(j.length>0){ for(;j.length>0;){var I=j.shift(),J=I.char,W=I.isNew;if(J===p&&g!==!0){N+=p;continue e}if(r[F].test(J)){if(y===!0&&W!==!1&&d!==l&&s!==!1&&O){for(var q=j.length,L=null,z=0;z<q;z++){var B=j[z];if(B.char!==p&&B.isNew===!1){ break; }if(B.char===p){L=z;break}}null!==L?(N+=J,j.splice(L,1)):F--;}else { N+=J; }continue e}E=!0;} }g===!1&&(N+=h.substr(F,P));break}N+=R;}if(g&&O===!1){for(var D=null,G=0;G<N.length;G++){ h[G]===p&&(D=G); }N=null!==D?N.substr(0,D+1):l;}return {conformedValue:N,meta:{someCharsRejected:E}}}Object.defineProperty(r,"__esModule",{value:!0});var o="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e};r.default=n;var i=t(4),a=t(1),u=[],l="";},function(e,r,t){function n(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:f,r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:s.placeholderChar;if(!o(e)){ throw new Error("Text-mask:convertMaskToPlaceholder; The mask property must be an array."); }if(e.indexOf(r)!==-1){ throw new Error("Placeholder character must not be used as part of the mask. Please specify a character that is not present in your mask as your placeholder character.\n\n"+("The placeholder character that was received is: "+JSON.stringify(r)+"\n\n")+("The mask that was received is: "+JSON.stringify(e))); }return e.map(function(e){return e instanceof RegExp?r:e}).join("")}function o(e){return Array.isArray&&Array.isArray(e)||e instanceof Array}function i(e){return "string"==typeof e||e instanceof String}function a(e){return "number"==typeof e&&void 0===e.length&&!isNaN(e)}function u(e){return "undefined"==typeof e||null===e}function l(e){for(var r=[],t=void 0;t=e.indexOf(d),t!==-1;){ r.push(t),e.splice(t,1); }return {maskWithoutCaretTraps:e,indexes:r}}Object.defineProperty(r,"__esModule",{value:!0}),r.convertMaskToPlaceholder=n,r.isArray=o,r.isString=i,r.isNumber=a,r.isNil=u,r.processCaretTraps=l;var s=t(1),f=[],d="[]";},function(e,r,t){function n(e){return e&&e.__esModule?e:{default:e}}function o(e){var r={previousConformedValue:void 0,previousPlaceholder:void 0};return {state:r,update:function(t){var n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:e,o=n.inputElement,s=n.mask,d=n.guide,m=n.pipe,g=n.placeholderChar,b=void 0===g?v.placeholderChar:g,C=n.keepCharPositions,P=void 0!==C&&C,k=n.showMask,x=void 0!==k&&k;if("undefined"==typeof t&&(t=o.value),t!==r.previousConformedValue){("undefined"==typeof s?"undefined":l(s))===y&&void 0!==s.pipe&&void 0!==s.mask&&(m=s.pipe,s=s.mask);var O=void 0,T=void 0;if(s instanceof Array&&(O=(0, p.convertMaskToPlaceholder)(s,b)),s!==!1){var w=a(t),M=o.selectionEnd,S=r.previousConformedValue,j=r.previousPlaceholder,_=void 0;if(("undefined"==typeof s?"undefined":l(s))===v.strFunction){if(T=s(w,{currentCaretPosition:M,previousConformedValue:S,placeholderChar:b}),T===!1){ return; }var V=(0, p.processCaretTraps)(T),A=V.maskWithoutCaretTraps,N=V.indexes;T=A,_=N,O=(0, p.convertMaskToPlaceholder)(T,b);}else { T=s; }var E={previousConformedValue:S,guide:d,placeholderChar:b,pipe:m,placeholder:O,currentCaretPosition:M,keepCharPositions:P},F=(0, c.default)(w,T,E),R=F.conformedValue,I=("undefined"==typeof m?"undefined":l(m))===v.strFunction,J={};I&&(J=m(R,u({rawValue:w},E)),J===!1?J={value:S,rejected:!0}:(0, p.isString)(J)&&(J={value:J}));var W=I?J.value:R,q=(0, f.default)({previousConformedValue:S,previousPlaceholder:j,conformedValue:W,placeholder:O,rawValue:w,currentCaretPosition:M,placeholderChar:b,indexesOfPipedChars:J.indexesOfPipedChars,caretTrapIndexes:_}),L=W===O&&0===q,z=x?O:h,B=L?z:W;r.previousConformedValue=B,r.previousPlaceholder=O,o.value!==B&&(o.value=B,i(o,q));}}}}}function i(e,r){document.activeElement===e&&(g?b(function(){return e.setSelectionRange(r,r,m)},0):e.setSelectionRange(r,r,m));}function a(e){if((0, p.isString)(e)){ return e; }if((0, p.isNumber)(e)){ return String(e); }if(void 0===e||null===e){ return h; }throw new Error("The 'value' provided to Text Mask needs to be a string or a number. The value received was:\n\n "+JSON.stringify(e))}Object.defineProperty(r,"__esModule",{value:!0});var u=Object.assign||function(e){
  var arguments$1 = arguments;
  for(var r=1;r<arguments.length;r++){var t=arguments$1[r];for(var n in t){ Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]); }}return e},l="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e};r.default=o;var s=t(2),f=n(s),d=t(3),c=n(d),p=t(4),v=t(1),h="",m="none",y="object",g="undefined"!=typeof navigator&&/Android/i.test(navigator.userAgent),b="undefined"!=typeof requestAnimationFrame?requestAnimationFrame:setTimeout;}])});
  });
  unwrapExports(textMaskCore);
  var textMaskCore_1 = textMaskCore.createTextMaskInputElement;
  var textMaskCore_2 = textMaskCore.textMaskCore;

  function createCurrencyFormat (ref) {
    var locale = ref.locale;
    var currency = ref.currency;
    var min = ref.min;
    var str = new Intl.NumberFormat(locale, { style: 'currency', currency: currency }).format(1234);
    var decimalLimit = (str.match(/0/g) || []).length;
    var decimalSymbol = decimalLimit > 0 ? str.substr(str.indexOf('4') + 1, 1) : null;
    var allowDecimal = decimalLimit !== 0;
    var prefix = str.substring(0, str.indexOf('1'));
    var suffix = str.substring(str.lastIndexOf(decimalLimit > 0 ? '0' : '4') + 1);
    var thousandsSeparatorSymbol = str.substr(str.indexOf('1') + 1, 1);
    var allowNegative = min == null || min < 0;
    return {
      prefix: prefix,
      suffix: suffix,
      thousandsSeparatorSymbol: thousandsSeparatorSymbol,
      decimalSymbol: decimalSymbol,
      decimalLimit: decimalLimit,
      allowDecimal: allowDecimal,
      allowNegative: allowNegative
    }
  }

  var onlyDigits = function (str) { return str.replace(/\D+/g, ''); };
  var endsWith = function (str, search) {
    return str.substring(str.length - search.length, str.length) === search
  };
  var startsWith = function (str, search) {
    return str.substring(0, search.length) === search
  };
  var removePrefix = function (str, prefix) {
    if (prefix && startsWith(str, prefix)) {
      return str.substr(prefix.length)
    }
    return str
  };
  var removeSuffix = function (str, suffix) {
    if (suffix && endsWith(str, suffix)) {
      return str.slice(0, suffix.length * -1)
    }
    return str
  };
  var parse = function (str, ref) {
    if ( ref === void 0 ) ref = {};
    var prefix = ref.prefix;
    var suffix = ref.suffix;
    var thousandsSeparatorSymbol = ref.thousandsSeparatorSymbol;
    var decimalSymbol = ref.decimalSymbol;
    if (typeof str === 'number') {
      return str
    } else if (str && typeof str === 'string') {
      if (str.match(/^-?\d+(\.\d+)?$/)) {
        return Number(str)
      }
      var negative = startsWith(str, '-');
      str = removePrefix(str, '-');
      str = removePrefix(str, prefix);
      str = removeSuffix(str, suffix);
      var numberParts = str.split(decimalSymbol);
      if (numberParts.length > 2) {
        return null
      }
      var integer = numberParts[0].replace(new RegExp(thousandsSeparatorSymbol === '.' ? '\\.' : thousandsSeparatorSymbol, 'g'), '');
      if (integer.length && !integer.match(/^\d+$/g)) {
        return null
      }
      var number = integer;
      if (numberParts.length === 2) {
        var fraction = numberParts[1];
        if (fraction.length && !fraction.match(/^\d+$/g)) {
          return null
        }
        number += "." + fraction;
      }
      if (number) {
        if (negative) {
          number = "-" + number;
        }
        return Number(number)
      }
    }
    return null
  };

  var digitRegExp = /\d/;
  var caretTrap = '[]';
  var convertToMask = function (strNumber) { return strNumber.split('').map(function (char) { return digitRegExp.test(char) ? digitRegExp : char; }); };
  function createCurrencyMask (ref) {
    if ( ref === void 0 ) ref = {};
    var prefix = ref.prefix;
    var suffix = ref.suffix;
    var thousandsSeparatorSymbol = ref.thousandsSeparatorSymbol;
    var allowDecimal = ref.allowDecimal;
    var allowNegative = ref.allowNegative;
    var decimalSymbol = ref.decimalSymbol;
    var decimalLimit = ref.decimalLimit;
    var prefixLength = prefix ? prefix.length : 0;
    var suffixLength = suffix ? suffix.length : 0;
    return function (rawValue) {
      if ( rawValue === void 0 ) rawValue = '';
      var indexOfDecimalSymbol = rawValue.indexOf(decimalSymbol);
      var hasDecimal = indexOfDecimalSymbol !== -1;
      var negative = startsWith(rawValue, '-') && allowNegative;
      rawValue = removePrefix(rawValue, '-');
      rawValue = removePrefix(rawValue, prefix);
      rawValue = removeSuffix(rawValue, suffix);
      var integer, fraction;
      if (hasDecimal && allowDecimal) {
        var numberParts = rawValue.split(decimalSymbol);
        integer = numberParts[0];
        fraction = convertToMask(onlyDigits(numberParts[1]));
      } else {
        integer = rawValue;
      }
      integer = onlyDigits(integer);
      integer = integer.replace(/^0+(0$|[^0])/, '$1');
      integer = integer.replace(/\B(?=(\d{3})+(?!\d))/g, thousandsSeparatorSymbol);
      var mask = convertToMask(integer);
      if (hasDecimal && allowDecimal) {
        mask.push(caretTrap, decimalSymbol, caretTrap);
        if (fraction) {
          if (typeof decimalLimit === 'number') {
            fraction = fraction.slice(0, decimalLimit);
          }
          mask = mask.concat(fraction);
        }
      }
      if (prefixLength > 0) {
        mask = prefix.split('').concat(mask);
      }
      if (negative) {
        mask = [/-/].concat(mask);
      }
      if (suffixLength > 0) {
        mask = mask.concat(suffix.split(''));
      }
      return mask
    }
  }

  function dispatchEvent (el, eventName, data) {
    var event = document.createEvent('CustomEvent');
    event.initCustomEvent(eventName, true, true, data);
    el.dispatchEvent(event);
  }

  function elementMatches (el, selector) { return (el.matches || el.msMatchesSelector || el.webkitMatchesSelector).call(el, selector); }

  var directive = {
    bind: function bind (el, ref, ref$1) {
      var options = ref.value;
      var context = ref$1.context;
      var inputElement = init(el, options, context.$CI_DEFAULT_OPTIONS || defaultOptions);
      Vue.nextTick(function () {
        if (inputElement.value) {
          applyFixedFractionFormat(inputElement);
        }
      });
      inputElement.addEventListener('input', function () {
        format(inputElement);
      }, { capture: true });
      inputElement.addEventListener('format', function (ref) {
        var detail = ref.detail;
        if (!inputElement.$ci.focus) {
          format(inputElement, detail.value);
        }
      });
      inputElement.addEventListener('focus', function () {
        var ref = inputElement.$ci;
        var options = ref.options;
        var currencyFormat = ref.currencyFormat;
        inputElement.$ci.focus = true;
        if (options.distractionFree) {
            var caretPosition = getCaretPosition(inputElement);
            format(inputElement, parse(inputElement.value, currencyFormat));
        }
      });
      inputElement.addEventListener('blur', function () {
        inputElement.$ci.focus = false;
        applyFixedFractionFormat(inputElement);
      });
    },
    componentUpdated: function componentUpdated (el, ref, ref$1) {
      var value = ref.value;
      var oldValue = ref.oldValue;
      var context = ref$1.context;
      if (!!value && optionsChanged(oldValue, value)) {
        var inputElement = init(el, value, context.$CI_DEFAULT_OPTIONS || defaultOptions);
        applyFixedFractionFormat(inputElement, inputElement.$ci.numberValue);
      }
    }
  };
  var optionsChanged = function (oldOptions, newOptions) {
    return Object.keys(defaultOptions).some(function (key) { return oldOptions[key] !== newOptions[key]; })
  };
  var init = function (el, optionsFromBinding, defaultOptions) {
    var inputElement = elementMatches(el, 'input') ? el : el.querySelector('input');
    if (!inputElement) {
      throw new Error('The directive must be applied on an element consists of an input element')
    }
    var options = Object.assign({}, defaultOptions, optionsFromBinding);
    if (options.min != null && options.max != null && options.min > options.max) {
      throw new Error('Invalid number range')
    }
    inputElement.$ci = Object.assign({}, inputElement.$ci || {},
      {options: options,
      currencyFormat: createCurrencyFormat(options),
      textMaskInputElement: textMaskCore_1({ inputElement: inputElement, mask: [] })});
    return inputElement
  };
  var applyFixedFractionFormat = function (el, value) {
    if ( value === void 0 ) value = parse(el.value, el.$ci.currencyFormat);
    if (value != null && !el.$ci.currencyFormat.allowDecimal) {
      value = Math.round(value);
    }
    format(el, value);
    dispatchEvent(el, 'input');
  };
  var format = function (el, value, ref) {
    if ( value === void 0 ) value = el.value;
    if ( ref === void 0 ) ref = el.$ci;
    var options = ref.options;
    var currencyFormat = ref.currencyFormat;
    var textMaskInputElement = ref.textMaskInputElement;
    var focus = ref.focus;
    var hideNegligibleFractionDigits = focus && (options.distractionFree === true || options.distractionFree.hideNegligibleFractionDigits);
    var hideCurrencySymbol = focus && (options.distractionFree === true || options.distractionFree.hideCurrencySymbol);
    var hideThousandsSeparatorSymbol = focus && (options.distractionFree === true || options.distractionFree.hideThousandsSeparatorSymbol);
    if (typeof value === 'number') {
      if (options.min != null && value < options.min) {
        value = options.min;
      }
      if (options.max != null && value > options.max) {
        value = options.max;
      }
      value = new Intl.NumberFormat(options.locale, { minimumFractionDigits: hideNegligibleFractionDigits ? 0 : currencyFormat.decimalLimit }).format(value);
      if (options.distractionFree) {
        value += ' ';
      }
    }
    textMaskInputElement.update(value, {
      inputElement: el,
      pipe: function (conformedValue, ref) {
        var previousConformedValue = ref.previousConformedValue;
        if (options.validateOnInput) {
          if (options.min != null && parse(conformedValue, currencyFormat) < options.min) {
            return previousConformedValue
          }
          if (options.max != null && parse(conformedValue, currencyFormat) > options.max) {
            return previousConformedValue
          }
        }
        return conformedValue
      },
      mask: createCurrencyMask(Object.assign({}, currencyFormat,
        {prefix: hideCurrencySymbol ? '' : currencyFormat.prefix,
        suffix: hideCurrencySymbol ? '' : currencyFormat.suffix,
        thousandsSeparatorSymbol: hideThousandsSeparatorSymbol ? '' : currencyFormat.thousandsSeparatorSymbol}))
    });
    var numberValue = parse(el.value, currencyFormat);
    el.$ci.numberValue = numberValue;
    dispatchEvent(el, 'format-complete', { numberValue: numberValue });
  };
  var getCaretPosition = function (el) {
    var ref = el.$ci.currencyFormat;
    var prefix = ref.prefix;
    var thousandsSeparatorSymbol = ref.thousandsSeparatorSymbol;
    var ref$1 = el.$ci.options;
    var distractionFree = ref$1.distractionFree;
    var hideCurrencySymbol = distractionFree === true || distractionFree.hideCurrencySymbol;
    var hideThousandsSeparatorSymbol = distractionFree === true || distractionFree.hideThousandsSeparatorSymbol;
    var position = el.selectionStart;
    if (hideCurrencySymbol) {
      position -= prefix.length;
    }
    if (hideThousandsSeparatorSymbol) {
      var thousandsSeparatorSymbolCount = (el.value.substring(0, el.selectionStart).match(new RegExp(thousandsSeparatorSymbol === '.' ? '\\.' : thousandsSeparatorSymbol, 'g')) || []).length;
      position -= thousandsSeparatorSymbolCount;
    }
    return Math.max(0, position)
  };

  function objectWithoutProperties (obj, exclude) { var target = {}; for (var k in obj) if (Object.prototype.hasOwnProperty.call(obj, k) && exclude.indexOf(k) === -1) target[k] = obj[k]; return target; }
  var component = {
    render: function render (h) {
      return h('input', {
        domProps: {
          value: this.formattedValue
        },
        directives: [{
          name: 'currency',
          value: this.options
        }],
        on: this.listeners()
      })
    },
    directives: {
      currency: directive
    },
    name: 'CurrencyInput',
    props: {
      value: {
        type: Number,
        default: null
      },
      locale: {
        type: String,
        default: undefined
      },
      currency: {
        type: String,
        default: undefined
      },
      distractionFree: {
        type: [Boolean, Object],
        default: undefined
      },
      min: {
        type: Number,
        default: undefined
      },
      max: {
        type: Number,
        default: undefined
      },
      validateOnInput: {
        type: Boolean,
        default: undefined
      }
    },
    data: function data () {
      return {
        formattedValue: this.value
      }
    },
    computed: {
      options: function options () {
        var this$1 = this;
        var options = Object.assign({}, this.$CI_DEFAULT_OPTIONS || defaultOptions);
        Object.keys(options).forEach(function (key) {
          if (this$1[key] !== undefined) {
            options[key] = this$1[key];
          }
        });
        return options
      }
    },
    watch: {
      value: function value (value$1) {
        dispatchEvent(this.$el, 'format', { value: value$1 });
      }
    },
    methods: {
      listeners: function listeners () {
        var this$1 = this;
        var ref = this.$listeners;
        var input = ref.input;
        var rest = objectWithoutProperties( ref, ["input"] );
        var listeners = rest;
        return Object.assign({}, listeners,
          {'format-complete': function (ref) {
            var detail = ref.detail;
            this$1.$emit('input', detail.numberValue);
            this$1.formattedValue = this$1.$el.value;
          }})
      }
    }
  };

  var plugin = {
    install: function install (Vue, ref) {
      if ( ref === void 0 ) ref = {};
      var componentName = ref.componentName; if ( componentName === void 0 ) componentName = component.name;
      var directiveName = ref.directiveName; if ( directiveName === void 0 ) directiveName = 'currency';
      var globalOptions = ref.globalOptions; if ( globalOptions === void 0 ) globalOptions = {};
      var options = Object.assign({}, defaultOptions, globalOptions);
      Vue.prototype.$CI_DEFAULT_OPTIONS = options;
      Vue.component(componentName, component);
      Vue.directive(directiveName, directive);
      Vue.prototype.$parseCurrency = function (str, locale, currency) {
        if ( locale === void 0 ) locale = options.locale;
        if ( currency === void 0 ) currency = options.currency;
        return parse(str, createCurrencyFormat(Object.assign({}, options, {locale: locale, currency: currency})))
      };
    }
  };

  if (typeof window !== 'undefined' && window.Vue) {
    window.Vue.use(plugin);
  }

}));
